import MuseScore 3.0
import QtQuick 2.9
import QtQuick.Controls 2.2
import QtQuick.Layouts 1.2
import QtQuick.Dialogs 1.2
import QtQuick.Window 2.2
import Qt.labs.settings 1.0
MuseScore {
  property string pname:"Humanize (batch edit Velocity and Tuning) (Docked)"
  menuPath: "Plugins."+pname
  version: "20231125A"
  Settings {
    id: settings
    category: "bvt2"
    property var userscript
  }
  Component.onCompleted:{
    if (mscoreMajorVersion >= 4) {
      pluginscope.title = pluginscope.pname
      // some_id.thumbnailName = "thumbnail.png";
      // some_id.categoryCode = "some_caregory";
    }
    ti.text=settings.userscript||"\
var vb=MF-10                          \n\
var vs=[                          \n\
0,-1,-2,-3,-2                          \n\
,-1,-2,-5,-1,-4                          \n\
,-2,-3,-3,-5                          \n\
].map(function(x){return x*3})                          \n\
var ts=[                          \n\
-3,0,-1,-4,-5                          \n\
,0,-4,-5,-4                          \n\
].map(function(x){return x*5})                          \n\
                          \n\
eachnote=function(e){                          \n\
if(button===3){e.veloType=0; e.veloOffset=0; e.tuning=0}                          \n\
if(button===2){e.veloType=1; e.veloOffset=vb; e.tuning=0}                          \n\
if(button===1){                          \n\
var ev=vb                          \n\
var et=0                          \n\
\/\/                          \n\
var v=vs.shift(), t=ts.shift(); vs.push(v); ts.push(t)                          \n\
ev+=v; et+=t                          \n\
\/\/all notes during first half beat                          \n\
if( tick(e)-beat1tick(e)<QUAVER ){ ev=vb }                          \n\
\/\/accent every half note                          \n\
if( (tick(e)-beat1tick(e))%MINIM===0 ){ ev+=10 }                          \n\
\/\/accent every whole note                          \n\
if( (tick(e)-beat1tick(e))%SEMIBREVE===0 ){ ev+=10 }                          \n\
\/\/                          \n\
e.veloType=1; e.veloOffset=Math.max(0,Math.min(127,ev)); e.tuning=et                          \n\
}                          \n\
}                          "
  }
  function btnrun(button){
    var map=function(o,f){var x=[];for(var i in o){x.push(f(o[i],+i))};return x}
    var filter=function(o,f){var x=[];for(var i in o){if(f(o[i],+i)==true) x.push(o[i])};return x}
    var dynMS=[ //dynamics actions plugin
       {v:1  ,l:0   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
      ,{v:5  ,l:3   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
      ,{v:10  ,l:7   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
      ,{v:16  ,l:13   ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
      ,{v:32  ,l:24  ,t:'<sym>dynamicPiano</sym><sym>dynamicPiano</sym>'}
      ,{v:48  ,l:40  ,t:'<sym>dynamicPiano</sym>'}
      ,{v:64  ,l:56  ,t:'<sym>dynamicMezzo</sym><sym>dynamicPiano</sym>'}
      ,{v:80  ,l:72  ,t:'<sym>dynamicMezzo</sym><sym>dynamicForte</sym>'}
      ,{v:96  ,l:88  ,t:'<sym>dynamicForte</sym>'}
      ,{v:112 ,l:104 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym>'}
      ,{v:126 ,l:119 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym>'}
      ,{v:127 ,l:127 ,t:'<sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym><sym>dynamicForte</sym>'}
    ]
    var PPP=dynMS[3].v
    var PP =dynMS[4].v
    var P  =dynMS[5].v
    var MP =dynMS[6].v
    var MF =dynMS[7].v
    var F  =dynMS[8].v
    var FF =dynMS[9].v
    var FFF=dynMS[10].v
    var DEMISEMIQUAVER=division/8
    var SEMIQUAVER=division/4
    var QUAVER=division/2
    var CROTCHET=division
    var MINIM=division*2
    var SEMIBREVE=division*4
    var N32=division/8
    var N16=division/4
    var N8=division/2
    var N4=division
    var N2=division*2
    var HALFNOTE=division*2
    var N1=division*4
    var FULLNOTE=division*4
    var WHOLENOTE=division*4
    var tick=function(e){return e.parent.parent.tick}
    var eachnote=function(){}
    var beat1tick=function(e){return e.parent.parent.parent.firstSegment.tick}
    var measureDuration=function(e){return e.parent.parent.parent.timesigActual.ticks}
    var measureTSN=function(e){return e.parent.parent.parent.timesigActual.numerator}
    var measureTSD=function(e){return e.parent.parent.parent.timesigActual.denominator}
    eval(ti.text)
    curScore.startCmd()
    map(filter(curScore.selection.elements,function(e){return e.type===Element.NOTE}),function(e){eachnote(e)})
    curScore.endCmd()
  }
  implicitHeight: 9999
  // menuPath: "Plugins.QMLlearning_Dockable"
  // version: "20230301A"
  id: pluginscope
  pluginType: "dock"
  property real wrapperwidth: 600 // use Screen if you need ratio based ui
  property int  pagemargintb:10; property int pagemarginlr:20 // use Screen if you need ratio based ui
  property real customwidth: Screen.desktopAvailableWidth*.2
  property real customheight: Screen.desktopAvailableHeight*.2
  onRun:{
    pluginscope.height=Math.min(customheight ,Screen.desktopAvailableWidth)
  }
  Page{ id:plugincontent
    anchors.fill: parent
    contentItem:Rectangle{ id:pagecontent
      color: "beige" 
      Flickable{ 
        anchors.fill:parent;
        contentWidth: grid.width; contentHeight: grid.height
        GridLayout{ id:grid
          columns: 1
          Column{ id:allcontent
            Layout.preferredWidth: pagecontent.width-Layout.leftMargin-Layout.rightMargin 
            Layout.leftMargin : pagemarginlr; Layout.rightMargin  :pagemarginlr
            Layout.topMargin  : pagemargintb; Layout.bottomMargin :pagemargintb
            Column{ id:innercontent
              width: parent.width
              //
              // Contents here
              TextArea{
                id:ti
                color: "black"
                selectByMouse:true
                width:parent.width 
                height:1000
                padding :0
              }
            }
          }
        }
      }
    }
    footer: ToolBar { //  ToolBar, TabBar, or DialogButtonBox  // ms3 Page footer is not bugged
      height:flow.height
      Item { id:stealfocus
        focus:true
        Keys.onPressed: { if (event.key == Qt.Key_Space) cmd("play")  }
      }
      contentItem:Rectangle{ color: "#eee"
        Flow{ id:flow; spacing :10 ; padding:10
          Button {
            text: 'Run 1'
            onClicked:{stealfocus.forceActiveFocus();btnrun(1)}
          }
          Button {
            text: 'Run 2'
            onClicked:{stealfocus.forceActiveFocus();btnrun(2)}
          }
          Button {
            text: 'Run 3'
            onClicked:{stealfocus.forceActiveFocus();btnrun(3)}
          }
          Button {
            text: 'SaveScript'
            onClicked:{stealfocus.forceActiveFocus();settings.userscript=ti.text}
          }
        }
      }
    }
  }
}